#include <Adafruit_NeoPixel.h>

#include <IRremote.h>

#include <NewPing.h>

/*Aqui se configuran los pines donde debemos conectar el sensor*/
#define TRIGGER_PIN  2
#define ECHO_PIN     3
#define MAX_DISTANCE 200

/*Crear el objeto de la clase NewPing*/
NewPing sonar(TRIGGER_PIN, ECHO_PIN, MAX_DISTANCE);

#include "DHT.h"

#define DHTPIN 7     

#define DHTTYPE DHT11  

DHT dht(DHTPIN, DHTTYPE);

#define PIN        8 //  Pin de control
#define NUMPIXELS 60 // Numero de pixels// Pausa al movel los pixels
Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

#define pinSensorIR 11

#define boton_1 0xFFA25D
#define boton_2 0xFF629D
#define boton_3 0xFFE21D

IRrecv sensorIR(pinSensorIR);
decode_results codigoIR;

byte R=0;
byte G=0;
byte B=0;
int valorR;
int valorG;
int valorB;
byte red = 3;
byte green = 6;
byte blue = 5;

void setup(){
  Serial.begin(9600);
  dht.begin();
  pixels.begin();
  sensorIR.enableIRIn();
}

void loop(){

  delay(2000);

  float h = dht.readHumidity();

  float t = dht.readTemperature();

  int temperatura = t * 6.375;  
  int humedad = h * 2.55;

  int uS = sonar.ping_median();

  int medida = uS / US_ROUNDTRIP_CM * 1.275;
  
  valorR = analogRead(A0);
  R = map(valorR, 0, 1023, 0, 255);
  
  valorG = analogRead(A1);
  G = map(valorR, 0, 1023, 0, 255);
  
  valorB = analogRead(A2);
  B = map(valorR, 0, 1023, 0, 255);
  
  Serial.println(temperatura);
  Serial.println(humedad);
  Serial.println(medida);

  
  if(sensorIR.decode(&codigoIR)){
    Serial.println(codigoIR.value, HEX);
    pixels.clear();
    sensorIR.resume();
    
  }
  if(codigoIR.value == boton_1){
    for(int i=0; i<NUMPIXELS; i++){ 
      pixels.setPixelColor(i, pixels.Color(temperatura, humedad, medida));
      pixels.show();}
  }
  if(codigoIR.value == boton_2){
    for(int i=0; i<NUMPIXELS; i++){ 
      pixels.setPixelColor(i, pixels.Color(0, 0, 0));
      pixels.show();}
  }
  if(codigoIR.value == boton_3){
    for(int i=0; i<NUMPIXELS; i++){ 
      pixels.setPixelColor(i, pixels.Color(R, G, B));
      pixels.show();
      } 
  }
}
